﻿using Dto;

namespace Shared;

public interface IAthleteService
{
    public Task<IEnumerable<AthleteDto>> GetAllAthletesAsync();
    public Task<IEnumerable<AthleteDto>> GetSomeAthletesAsync(int index, int count, AthleteOrderCriteria criterium);
    public Task<AthleteDto?> GetAthleteByIdAsync(int id);
    public Task<IEnumerable<AthleteDto>> GetAthleteByUsernameAsync(string username, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByEmailAsync(string email, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByFirstNameAsync(string firstName, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByLastNameAsync(string lastName, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesBySexeAsync(string sexe, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByLenghtAsync(double lenght, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByWeightAsync(float weight, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByDateOfBirthAsync(DateTime dateOfBirth, int index, int count, AthleteOrderCriteria criterium);
    public Task<IEnumerable<AthleteDto>> GetAthletesByIsCoachAsync(bool isCoach, int index, int count, AthleteOrderCriteria criterium);
    public Task<AthleteDto> AddAthleteAsync(AthleteDto athlete, AthleteOrderCriteria criterium);
    public Task<AthleteDto?> UpdateAthleteAsync(int id, AthleteDto athlete, AthleteOrderCriteria criterium);
    public Task<bool> DeleteAthleteAsync(int id, AthleteOrderCriteria criterium);

}